require 'rails/generators/base'

module LoriotRb
  module Generators
    class InstallGenerator < Rails::Generators::Base
      desc 'Installs LoriotRb configuration files'
      source_root File.expand_path('../../', __FILE__)
      # class_option :protocol, :type => :string, :default => 'tls', :desc => "Choose your favorite emulator [tls]"

      def copy_to_local
        # copy_file '../config/settings.yml', 'config/loriot_rb.yml'
        copy_file '../config/private_EXAMPLE.yml', 'config/loriot_rb_private.yml'
        file = 'config/initializers/loriot-rb.rb'
        copy_file '../config/config.rb', file
        append_file file do
          <<-FILE.gsub(/^            /, '')
            connection_protocol = LoriotRb.configuration.protocol
            raise 'Define your protocol in the configuration file!' unless connection_protocol
            raise "Connection protocol #{connection_protocol} not recognized!" unless %w(tls).include?(connection_protocol.to_s)
            require "loriot-rb/#{connection_protocol}/call"
            LoriotClient.include LoriotRb::Call
          
            %w(loriot_rb_private.yml).each  do |file|
              filepath = File.join(Rails.root,'config',file)
              LoriotRb::Settings.load!(filepath,env: LoriotRb.configuration.env) if File.exist? filepath
            end
            raise 'Insert your secret data to login on the loriot cloud!' unless LoriotRb::Settings.appid.present? && LoriotRb::Settings.token.present?
          FILE
        end
      end
    end
  end
end