# LoriotRb
# Copyright (C) 2017  Marco Mastrodonato, marco.mastrodonato@fractalgarden.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

require 'json'
require 'socket'
require 'openssl'

require_relative 'core/configuration'
require_relative 'core/configuration_dynamic'

module LoriotRb
  def self.root
    File.expand_path('../..', __FILE__)
  end
end

require_relative 'version'
require_relative 'loriot-rb/base'

unless defined?(Rails)
  require_relative 'config/config'

  connection_protocol = LoriotRb.configuration.protocol
  raise "Define your protocol in the configuration file!" unless connection_protocol
  raise "Connection protocol #{connection_protocol} not recognized!" unless %w(tls).include?(connection_protocol.to_s)
  require_relative "loriot-rb/#{connection_protocol}/call"
  LoriotClient.include LoriotRb::Call

  %w(private.yml).each  do |file|
    filepath = File.join(LoriotRb.root,'lib','config',file)
    LoriotRb::Settings.load!(filepath,env: LoriotRb.configuration.env) if File.exist? filepath
  end
  raise "Insert your secret data to login on the loriot cloud!" if LoriotRb::Settings.appid.nil? || LoriotRb::Settings.token.nil?
end

